/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * nsIAppShell.idl
 */

package org.mozilla.interfaces;

/**
 * Interface for the native event system layer.  This interface is designed
 * to be used on the main application thread only.
 */
public interface nsIAppShell extends nsISupports {

  String NS_IAPPSHELL_IID =
    "{3785230a-da91-4eaa-8a25-56acc7ff35d0}";

  /**
   * Enter an event loop.  Don't leave until exit() is called.
   */
  void run();

  /**
   * Exit the handle event loop
   */
  void exit();

  /**
   * Give hint to native event queue notification mechanism. If the native
   * platform needs to tradeoff performance vs. native event starvation this
   * hint tells the native dispatch code which to favor.  The default is to
   * prevent native event starvation.
   *
   * Calls to this function may be nested. When the number of calls that pass
   * PR_TRUE is subtracted from the number of calls that pass PR_FALSE is
   * greater than 0, performance is given precedence over preventing event
   * starvation.
   *
   * The starvationDelay arg is only used when favorPerfOverStarvation is
   * PR_FALSE. It is the amount of time in milliseconds to wait before the
   * PR_FALSE actually takes effect.
   */
  void favorPerformanceHint(boolean favorPerfOverStarvation, long starvationDelay);

}